
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="generator" content="Docutils 0.17.1: http://docutils.sourceforge.net/" />

    <title>Using inline C to extend Varnish &#8212; Varnish version 6.0.11 documentation</title>
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/classic.css" />
    
    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="VCL Examples" href="vcl-examples.html" />
    <link rel="prev" title="Separate VCL files" href="vcl-separate.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="vcl-examples.html" title="VCL Examples"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="vcl-separate.html" title="Separate VCL files"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" >The Varnish Users Guide</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="vcl.html" accesskey="U">VCL - Varnish Configuration Language</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">Using inline C to extend Varnish</a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <section id="using-inline-c-to-extend-varnish">
<h1>Using inline C to extend Varnish<a class="headerlink" href="#using-inline-c-to-extend-varnish" title="Permalink to this headline">¶</a></h1>
<p>(Here there be dragons. Big and mean ones.)</p>
<p>You can use <em>inline C</em> to extend Varnish. Please note that you can
seriously mess up Varnish this way. The C code runs within the Varnish
Cache process so if your code generates a segfault the cache will crash.</p>
<p>One of the first uses of inline C was logging to <cite>syslog</cite>.:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="c1"># The include statements must be outside the subroutines.</span>
<span class="n">C</span><span class="p">{</span>
        <span class="c1">#include &lt;syslog.h&gt;</span>
<span class="p">}</span><span class="n">C</span>

<span class="n">sub</span> <span class="n">vcl_something</span> <span class="p">{</span>
        <span class="n">C</span><span class="p">{</span>
                <span class="n">syslog</span><span class="p">(</span><span class="n">LOG_INFO</span><span class="p">,</span> <span class="s2">&quot;Something happened at VCL line XX.&quot;</span><span class="p">);</span>
        <span class="p">}</span><span class="n">C</span>
<span class="p">}</span>
</pre></div>
</div>
<p>To use inline C you need to enable it with the <code class="docutils literal notranslate"><span class="pre">vcc_allow_inline_c</span></code>
parameter.</p>
</section>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h4>Previous topic</h4>
  <p class="topless"><a href="vcl-separate.html"
                        title="previous chapter">Separate VCL files</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="vcl-examples.html"
                        title="next chapter">VCL Examples</a></p>
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="../_sources/users-guide/vcl-inline-c.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="vcl-examples.html" title="VCL Examples"
             >next</a> |</li>
        <li class="right" >
          <a href="vcl-separate.html" title="Separate VCL files"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" >The Varnish Users Guide</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="vcl.html" >VCL - Varnish Configuration Language</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">Using inline C to extend Varnish</a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2010-2014, Varnish Software AS.
      Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 4.3.2.
    </div>
  </body>
</html>